﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;
using System.Windows.Data;

namespace xamPieChart_SliceColors
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
    }

    public class DataItem
    {
        public string Label { get; set; }
        public double Value { get; set; }

        public SolidColorBrush Color { get; set; }
    }

    public class Data : ObservableCollection<DataItem>
    {
        public Data()
        {
            Add(new DataItem { Label = "Item 1", Value = 5, Color = new SolidColorBrush(Colors.Red), });
            Add(new DataItem { Label = "Item 2", Value = 6, Color = new SolidColorBrush(Colors.Green), });
            Add(new DataItem { Label = "Item 3", Value = 3, Color = new SolidColorBrush(Colors.Blue), });
            Add(new DataItem { Label = "Item 4", Value = 7, Color = new SolidColorBrush(Colors.Yellow), });
            Add(new DataItem { Label = "Item 5", Value = 5, Color = new SolidColorBrush(Colors.Magenta), });
        }
    }

    public class PieChartAttachedProperties : DependencyObject
    {
        public static bool GetBindSliceBackground(DependencyObject obj)
        {
            return (bool)obj.GetValue(BindSliceBackgroundProperty);
        }

        public static void SetBindSliceBackground(DependencyObject obj, bool value)
        {
            obj.SetValue(BindSliceBackgroundProperty, value);
        }

        // Using a DependencyProperty as the backing store for BindSliceBackground.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BindSliceBackgroundProperty =
            DependencyProperty.RegisterAttached("BindSliceBackground", typeof(bool), typeof(PieChartAttachedProperties), new PropertyMetadata(false, OnBindSliceBackgroundChanged));

        static List<Slice> Slices = new List<Slice>();

        private static void OnBindSliceBackgroundChanged(DependencyObject o, DependencyPropertyChangedEventArgs e)
        {
            Slice slice = (Slice)o;
            slice.LayoutUpdated += new EventHandler(slice_LayoutUpdated);
            Slices.Add(slice);
        }

        static void slice_LayoutUpdated(object sender, EventArgs e)
        {
            // Layout updated doesn't tell me which slice is updating so just handle them all.
            foreach (Slice slice in Slices)
            {
                Binding b = new Binding("Color");
                slice.SetBinding(Slice.BackgroundProperty, b);
            }

            System.Diagnostics.Debug.WriteLine("LayoutUpdated");
        }
    }
}
